/*
 *
 *                          Device Node Soft Link Build Program
 *
 *
 *
 *                                                              Version: 1.00
 *                                                              Date: 2006/02/24
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

#define true	1
#define false	0

int main(void)
{
	int i,j,k,len,lenSource,lenTarget,status;
	unsigned char program_end;

	program_end = false;
	
	
	while (!program_end){
	
		char line[80];
		char source[20];
		char target[20];
		char targetBak[20];
		char tmp[20];
		
		printf("Please enter command (? for help):");
		fflush(stdout);
		fgets(line,sizeof(line) -1,stdin);
		
		switch(line[0]) {
			case '?':
				printf("\ncommands are:\n");
				printf("?   help (this text)\n");
				printf("B   build soft link in /dev (for example, B ttySNX0 ttyS4)\n");
				printf("A   backup device node in /dev (for example, A ttyS4)\n");
				printf("R   remove device node in /dev (for example, R ttyS4)\n");
				printf("Q   program end\n");
				break;
								
			case 'b':
			case 'B':

				j = 0;
				k = 0;
				len = strlen(line);

				memset(source,0,sizeof(source));
				memset(target,0,sizeof(target));
                    		memset(tmp,0,sizeof(tmp));

 				target[0] = source[0] = '/';
				target[1] = source[1] = 'd';
				target[2] = source[2] = 'e';
				target[3] = source[3] = 'v';
				target[4] = source[4] = '/';

				for(i = 0; i < len -1; i ++){
					if( ((line[i] == ' ')&&(k == 0)) ||(line[i] == 'b')||(line[i] == 'B') ){

						if(line[i] == ' ')
							k = 1;
						continue;
						}

					tmp[j] = line[i];
					j++;
					}
	
                    		j = 5;
				len = strlen(tmp);
				for(i = 0; i < len; i ++){
					if( tmp[i] == ' ' )
						break;
					source[j] = tmp[i];
					j++;
					}

  				lenSource = strlen(source);

				j = 5;
				for(i = lenSource -j; i < len; i++){
					if( tmp[i] == ' ' )
						continue;
					target[j] = tmp[i];
					j++;
					}
                 
                    		status = symlink(source,target);

				if(status)
					perror("symlink");
				else
					printf("build softlink successful\n");				
       					
				break;

			case 'a':
			case 'A':
				j = 0;
				len = strlen(line);
				memset(target,0,sizeof(target));
				memset(targetBak,0,sizeof(targetBak));
                    		memset(tmp,0,sizeof(tmp));

				target[0] = targetBak[0] = '/';
				target[1] = targetBak[1] = 'd';
				target[2] = targetBak[2] = 'e';
				target[3] = targetBak[3] = 'v';
				target[4] = targetBak[4] = '/';

				for(i = 0; i < len -1; i ++){
					if( (line[i] == ' ')||(line[i] == 'a')||(line[i] == 'A') )
						continue;
					tmp[j] = line[i];
					j++;
					}
 				strcat(target,tmp);
 				strcat(targetBak,tmp);
 				strcat(targetBak,".bak");

                    		status = rename(target,targetBak);

				if(status)
					perror("rename");
				else
					printf("backup successful\n");

                    		break;

								
			case 'r':
			case 'R':
				j = 0;
				len = strlen(line);

				memset(target,0,sizeof(target));
                    		memset(tmp,0,sizeof(tmp));

				target[0] = '/';
				target[1] = 'd';
				target[2] = 'e';
				target[3] = 'v';
				target[4] = '/';

				for(i = 0; i < len -1; i ++){
					if( (line[i] == ' ')||(line[i] == 'r')||(line[i] == 'R') )
						continue;
					tmp[j] = line[i];
					j++;
					}

				strcat(target,tmp);
  		                status = unlink(target);

				if(status)
			  		perror("unlink");
				else
					printf("remove successful\n");

				break;
												
			case 'q':
			case 'Q':
				printf("program end\n");
				program_end = true;
				break;
								
			default:
				break;
								
		}	
	}						
 return(0);
}
